package com.yihu.ehr.basic.fileresource.service;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @author linaz
 * @created 2016.05.12 8:53
 */
public interface XFileResourceRepository extends PagingAndSortingRepository<FileResource, String> {
    @Query("select fileResource from FileResource fileResource where fileResource.objectId = :objectId")
    List<FileResource> findByObjectId(@Param("objectId")String objectId);

    List<FileResource> findByStoragePath(String storagePath);

    @Query("select fileResource from FileResource fileResource where fileResource.objectId = :objectId and fileResource.mime = :mime ")
    List<FileResource> findByObjectIdAndMime(@Param ("objectId")String objectId, @Param ("mime")String mime);

    FileResource findById(String id);
}
