package com.yihu.ehr.commons.constants;

/**
 * 微服务REST API. 此处定义的URL可用于服务对外提供的地址及HTTP客户端请求地址.
 * URL定义遵循健康档案平台REST规范.
 *
 * @author zdm
 * @version 1.0
 * @created 2018.09.05 15:04
 */
public class BasicServiceApi {

    public static class Users {

        //存在于私有库-start
        public static final String Users = "/users";
        public static final String UsersOfApp = "/usersOfApp";
        public static final String User = "/users/{user_name}";
        public static final String UserExistence = "/users/{user_name}/existence";
        public static final String UserVerification = "/users/verification";
        public static final String UserAdmin = "/users/admin/{user_id}";
        public static final String UserAdminPassword = "/users/admin/{user_id}/password";
        public static final String UserAdminPasswordReset = "/users/admin/{user_id}/password_reset";
        public static final String UserAdminKey = "/users/admin/{user_id}/key";
        public static final String UserAdminContact = "/users/admin/{user_id}/contact";
        public static final String UserIdCardNoExistence = "/user/id_card_no/existence";
        public static final String UserEmailNoExistence = "/user/email/existence";
        public static final String UserTelephoneNoExistence = "/user/telephone/existence";
        public static final String UserPhoneExistence = "/user/phone/existence";
        public static final String UserOnePhoneExistence = "/user/onePhone/existence";
        public static final String UserEmailExistence = "/user/email/existence";
        public static final String UseridCardNoExistence = "/user/idCardNo/existence";
        public static final String UserByIdCardNo = "/user/idCardNo/userByIdCardNo";
        public static final String UpdateSystemUser = "/updateSystemUser";
        public static final String GetOrgAndDeptRelation = "/users/getOrgAndDeptRelation";
        public static final String InitializeSystemUser = "/users/initialize";
        public static final String UsersByTel = "/users/tel";
        public static final String H5Handshake = "/users/h5/handshake";
        public static final String UsersOfAppPhoneExistence = "/usersOfApp/user/onePhone/existence";
        public static final String GetUserOfUsersOfApp = "/usersOfApp/users/getUserOfUsersOfApp";
        public static final String GetUserInfoAndRolesByUserIdOrCode = "/users/orgDeptMember/getUserInfoAndRolesByUserIdOrCode";
        public static final String Save = "/users/save";
        public static final String Update = "/users/update";
        public static final String Check = "/users/check";
        public static final String ChangePassword = "/users/changePassword";
        public static final String DistributeSecurityKey = "/users/distributeSecurityKey";
        public static final String GetSecurityKey = "/users/getSecurityKey";
        public static final String changePasswordByTelephone = "/usersOfApp/users/changePasswordByTelephone";
        public static final String changePasswordByOldPassword = "/users/changePasswordByOldPassword";
        public static final String updateUserTelePhone = "/users/updateTelephone";
        public static final String initializationAuthorization = "/users/initializationAuthorization";
        //存在于私有库-end


        //basic服务拆分之后追加
        public static final String GetUserByLoginCode = "/users/GetUserByLoginCode/{userName}";
        public static final String UpdateUserByUsers = "/users/UpdateUserByUsers";
    }


    public static class Doctors {
        //私有库已存在-start
        public static final String Doctors = "/doctors";
        public static final String DoctorsExistence = "/doctors/{doctor_code}/existence";
        public static final String DoctorAdmin = "/doctors/admin/{doctor_id}";
        public static final String DoctorByIdCardNo = "/doctor/{idCardNo}";
        public static final String DoctorPhoneExistence = "/doctor/phone/existence";
        public static final String DoctorBatch = "/doctor/batch";
        public static final String DoctorOnePhoneExistence = "/doctor/onePhone/existence";
        public static final String DoctorEmailExistence = "/doctor/email/existence";
        public static final String DoctorsIdCardNoExistence = "/doctors/{doctor_idCardNo}/CardNoExist";
        public static final String DoctoridCardNoExistence = "/doctor/idCardNo/existence";
        public static final String DoctorOnlyUpdateD = "/doctors/updateOnlyDoctor";

        public Doctors() {
        }
        //私有库已存在-end

        //basic服务拆分之后追加
        public static final String GetDoctorById = "/doctors/GetDoctorById/{doctor_id}";

    }

    //私有库已存在-start
    public static class Org {
        public static final String getUserOrglistByUserId = "/org/getUserOrglistByUserId/";
        public static final String getUserOrgSaasByUserOrgCode = "/org/getUserOrgSaasByUserOrgCode/";
        public static final String GetOrgDeptsDate = "/org/getOrgDeptsDate";
        public static final String GetOrgDeptInfoList = "/org/userId/getOrgDeptInfoList";
        public static final String getseaOrgsByOrgCode = "/organizations/seaOrgsByOrgCode";
        public static final String ChildOrgSaasByAreaCode = "/org/childOrgSaasByAreaCode";
        public static final String getOrgCodeAndFullName = "/org/getOrgCodeAndFullName";
        public static final String getUserOrgCodelistByUserId = "/org/getUserOrgCodelistByUserId";
        public Org() {
        }
        //私有库已存在-end

        //basic服务拆分之后追加
        public static final String getAllOrgByAdministrativeDivision = "/org/getAllOrgByAdministrativeDivision";


        public static class HealthCategory {
            //私有库已存在-start
            public static final String Prefix = "/org/healthCategory/";
            public static final String GetById = "/org/healthCategory/{id}";
            public static final String FindAll = "/org/healthCategory/findAll";
            public static final String Search = "/org/healthCategory/search";
            public static final String Save = "/org/healthCategory/save";
            public static final String Delete = "/org/healthCategory/delete";
            public static final String IsUniqueCode = "/org/healthCategory/isUniqueCode";
            public static final String IsUniqueName = "/org/healthCategory/isUniqueName";

            public HealthCategory() {
            }

            //私有库已存在-end
        }


    }


}
